package test;

public class TPCBBenchmark {
	
	
	public static void main(String[] args){
		
		
		TPCBBenchmark benchmark = new TPCBBenchmark();
		benchmark.startBenchMark(9);
		
	}
	
	public void startBenchMark(int numClients){
		System.out.println("Starting benchmark with " + numClients + " clients");
		for (int i = 1; i <= numClients; i++){
			new Thread(new TPCBClient(i)).start();
		}
		
	}
	
	
	
	private class TPCBClient extends Thread{

		private int clientId;
		
		public TPCBClient(int clientId){
			this.clientId = clientId;
		}
		

		
		public void run(){
			// ti minutter;
			System.out.println("Running client " + clientId);
			long runTime = 1000 * 60 * 60;
			long start = System.currentTimeMillis();
			long end = start + runTime;
			long totalResponseTime = 0;
			int completedTransactions = 0;
			long maxResponseTime = -1;
			long minResponseTime = -1;
			TPCBOperation operation = new TPCBOperation();
			
			while (System.currentTimeMillis() <= end){
				long tid = Math.round(Math.random() * (TPCBInit.ntellers*TPCBInit.tps - 1)) + 1;
				long aid = Math.round(Math.random() * (TPCBInit.naccounts*TPCBInit.tps - 1)) + 1;

				long delta = Math.round(Math.random() * 1000);
				
				long transStartTime = System.currentTimeMillis();
				operation.doOneOperation(1, tid, aid, delta);
				long responseTime = System.currentTimeMillis() - transStartTime;
				
				if (maxResponseTime < responseTime || maxResponseTime == -1)
					maxResponseTime = responseTime;
				if (minResponseTime > responseTime || minResponseTime == -1)
					minResponseTime = responseTime;
				
				totalResponseTime += responseTime;
				++completedTransactions;
				
//				System.out.println("[Operation " + ++completedTransactions + "]: " + TPCBOperation.getInstance().doOneOperation(1, tid, aid, delta));
			}
			
			System.out.println("[" + clientId + "] Completed transactions: " + completedTransactions);
			System.out.println("[" + clientId + "] Transactions per second: " + (double) Math.round(((double) completedTransactions / (runTime / 1000)) * 100) / 100);
			System.out.println("[" + clientId + "] Average response time: " + totalResponseTime / completedTransactions);
			System.out.println("[" + clientId + "] Minimum response time: " + minResponseTime);
			System.out.println("[" + clientId + "] Maximum response time: " + maxResponseTime);
			
		}
	}
}
