package test;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

public class TPCBInit {
	
    public final static long tps = 1;
    public final static long nbranches = 1;
    public final static long ntellers = 10;
    public final static long naccounts = 100000;
    public final static long nhistory = 864000;
	
	public static void main(String[] args){
		System.out.println("[CONNECT] Connecting...");
        try {
			Class.forName("org.apache.derby.jdbc.ClientDriver").newInstance();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//        System.out.println("Loaded the appropriate driver.");

        Connection conn = null;
        Properties props = new Properties();
        props.put("user", "user1");
        props.put("password", "user1");

        /*
           The connection specifies create=true to cause
           the database to be created. To remove the database,
           remove the directory derbyDB and its contents.
           The directory derbyDB will be created under
           the directory that the system property
           derby.system.home points to, or the current
           directory if derby.system.home is not set.
         */
        
        try{
	        conn = DriverManager.getConnection(
	        		"jdbc:derby://prosjekt.xn--egilsrensen-kgb.dk:1527/TPCB;create=true",
	        		props);
	
	//        System.out.println("Connected to and created database derbyDB");
	
	        conn.setAutoCommit(false);
	
	        /*
	           Creating a statement lets us issue commands against
	           the connection.
	         */
	        Statement s = conn.createStatement();
	        
	        
	        /*
	         * Initialize variables
	         */
	        

	        
	        
	        /*
	         * Create the tables
	         */
	        
	        System.out.println("[CREATE] Tables");
	        s.execute("CREATE TABLE branches (Bid NUMERIC(9), PRIMARY KEY(Bid)," +
	        		"Bbalance NUMERIC(10), filler CHAR(88)" +
	        		" DEFAULT 'SYSTEM')");
	        
	        s.execute("CREATE TABLE tellers ("+ 
	        		"Tid NUMERIC(9) PRIMARY KEY,"+ 
	        		"Bid NUMERIC(9),"+ 
	        		"Tbalance NUMERIC(10),"+ 
	        		"filler CHAR(84) DEFAULT 'SYSTEM'," +
	        		"FOREIGN KEY (Bid) REFERENCES branches(Bid))");
	        
	        s.execute("CREATE TABLE accounts ("+ 
	        		"Aid NUMERIC(9) PRIMARY KEY,"+ 
	        		"Bid NUMERIC(9),"+ 
	        		"Abalance NUMERIC(10),"+ 
	        		"filler CHAR(84) DEFAULT 'SYSTEM'," +
	        		"FOREIGN KEY (Bid) REFERENCES branches(Bid)"+ 
	        		")");
	        
	        s.execute("CREATE TABLE history ("+ 
	        		"Tid NUMERIC(9) REFERENCES tellers(Tid),"+ 
	        		"Bid NUMERIC(9) REFERENCES branches(Bid),"+ 
	        		"Aid NUMERIC(9) REFERENCES accounts(Aid),"+ 
	        		"delta NUMERIC(10),"+ 
	        		"time TIMESTAMP PRIMARY KEY,"+ 
	        		"filler CHAR(22) DEFAULT 'SYSTEM'" +
	        		")"); 
	        
	        s.close();
	        
	        /*
	         * Prime the database
	         */
	        
	        PreparedStatement ps;
	        
	        int affRows = 0;
	        System.out.println("[INSERT] branches");
	        ps = conn.prepareStatement("INSERT INTO branches(Bid, Bbalance) VALUES (?,0)");
	        for (int i = 1; i <= nbranches*tps; i++){
	        	ps.setInt(1, i);
	        	affRows += ps.executeUpdate();
	        }
	        
	        System.out.println("[INSERT] tellers");
	        ps = conn.prepareStatement("INSERT INTO tellers(Tid,Bid,Tbalance) VALUES (?,?,0)");
	        for (int i = 1; i <= ntellers*tps; i++){
	        	ps.setInt(1, i);
	        	ps.setLong(2, 1);
	        	affRows += ps.executeUpdate();
	        }
	        
	        System.out.println("[INSERT] accounts");
	        ps = conn.prepareStatement("INSERT INTO accounts(Aid,Bid,Abalance) VALUES (?,?,0)");
	        for (int i = 1; i <= naccounts*tps; i++){
	        	ps.setInt(1, i);
	        	ps.setLong(2, 1);
	        	affRows += ps.executeUpdate();
	        }
	        
	        System.out.println("Succesfully set up and primed the database");
	        System.out.println("Affected rows: " + affRows);
	        System.out.println("[DONE]");
	        
	        ps.close();
	        
	        conn.commit();
	        
	        conn.close();
	        
        } catch (SQLException e){
        	e.printStackTrace();
        }
        

	}
}
