package test;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Properties;

public class TPCBOperation {
	private Connection conn;
	private Properties props;
	private PreparedStatement ps1;
	private PreparedStatement ps2;
	private PreparedStatement ps3;
	private PreparedStatement ps4;
	private PreparedStatement ps5;
	
	
	public TPCBOperation(){
        try {
			Class.forName("org.apache.derby.jdbc.ClientDriver").newInstance();

		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//        System.out.println("Loaded the appropriate driver.");

        conn = null;
        props = new Properties();
        props.put("user", "user1");
        props.put("password", "user1");
        
        try{
//	        String url = "prosjekt.xn--egilsrensen-kgb.dk";
//	        String url = "thorfinn.egilnett.com";
//	        String url = "login.stud.ntnu.no";
        	String url = "lachdanan.egilnett.com";
//        	String url = "kratas.egilnett.com";
	        conn = DriverManager.getConnection(
	        		"jdbc:derby://" + url + ":1527/TPCB;create=true",
	        		props);
	
	//        System.out.println("Connected to and created database derbyDB");
	
	        conn.setAutoCommit(false);
	        
			ps1 = conn.prepareStatement("UPDATE accounts SET Abalance = Abalance + ? WHERE Aid = ?");
			ps2 = conn.prepareStatement("SELECT Abalance FROM accounts WHERE Aid = ?");
			ps3 = conn.prepareStatement("UPDATE tellers SET Tbalance = Tbalance + ? WHERE Tid = ?");
			ps4 = conn.prepareStatement("UPDATE branches SET Bbalance = Bbalance + ? WHERE Bid = ?");
			ps5 = conn.prepareStatement("INSERT INTO history(Tid, Bid, Aid, delta, time) VALUES(?,?,?,?,?)");
	        
	        
        } catch (SQLException e){
        	e.printStackTrace();
        }
        
	}
	
	
	
	
	public synchronized long doOneOperation(long bid, long tid, long aid, long delta){
		try{
		
			long abalance = -1;
			
			
			ps1.setLong(1, delta);
			ps1.setLong(2, aid);
			ps1.executeUpdate();
			
			ps2.setLong(1, aid);
			ResultSet rs = ps2.executeQuery();
			
			if (rs.next())
				abalance = rs.getLong("Abalance");
			
			ps3.setLong(1, delta);
			ps3.setLong(2, tid);
			ps3.executeUpdate();
			
			ps4.setLong(1, delta);
			ps4.setLong(2, bid);
			ps4.executeUpdate();
			
			ps5.setLong(1, tid);
			ps5.setLong(2, bid);
			ps5.setLong(3, aid);
			ps5.setLong(4, delta);
			Timestamp time = new Timestamp(System.currentTimeMillis());
			ps5.setTimestamp(5, time);
			ps5.execute();
			
			if (Math.random() < 0.99)
				conn.commit();
			else
				conn.rollback();
			
			return abalance;
		
		} catch (SQLException e){
			e.printStackTrace();
			return -1;
		}
		
	}
	
	
	
	
}
