package org.apache.derby.iapi.store.logical.log;

import java.io.Serializable;
import java.util.Hashtable;

import org.apache.derby.iapi.types.DataType;
import org.apache.derby.iapi.types.DataValueDescriptor;

/**
 * Interface for a class to hold a logical before- or afterimage of a record/tuple
 * 
 * @author egil
 *
 */

public interface LogicalImage extends Serializable {
	
	public int getType();
	
	public String getKey();
	
	public int size();
	
	public Hashtable getContents();
	
	public String getKeyColumnName();
	
	public static final int UNDO = 1;
	public static final int REDO = 2;

}
