package org.apache.derby.iapi.store.logical.log;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.derby.iapi.types.DataValueDescriptor;
/**
 * Interface for a logical loggable operation
 * @author egil
 *
 */
public interface LogicalLoggable extends Serializable{
	
	public int group();
	
	public boolean isRedoable();
	
	public boolean isUndoable();
	
	public LogicalImage getUndoImage();
	
	public LogicalImage getRedoImage();
	
	public String getTableName();
	
	public DataValueDescriptor getOldKey();
	
	public DataValueDescriptor getNewKey();
	
	public int redoMe(Connection conn) throws SQLException;
	
	public int undoMe(Connection conn) throws SQLException;
	
	
	public static final int UPDATE_OPERATION = 1;
	public static final int DELETE_OPERATION = 2;
	public static final int INSERT_OPERATION = 3;
	public static final int COMMIT_OPERATION = 4;
	public static final int ABORT_OPERATION = 5;

}
